/*  
 *  blogin.c
 *
 *  Version 1.9
 *  26 July 1999 
 *
 *   LOGIN PROGRAM
 *
 *   Realised by MARTINEZ Sylvain  
 *
 *   Based on the BUGS crypt's algorithm of MARTINEZ Sylvain  
 *   (Big and Usefull Great Security)  
 *
 *   UNIX Administrator (Merrill Lynch, UK) 
 *   Network Security Consultant (ASI, France)
 *   Passion: Cryptology and Network Security  
 *   email: martinez@asi.fr  
 *          sylvain.martinez@netcourrier.com 
 *   URL: http://www.asi.fr/~martinez
 *
 *  Copyright (C) 1996,1997,1998,1999 MARTINEZ Sylvain  
 *  THIS IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY IT UNDER  
 *  THE TERMS OF THE GNU GENERAL PUBLIC LICENSE, see the file COPYING.  
 */

/* PLEASE READ THAT :


                              USES  WARNING
                              -------------

 YOU MUST CREATE A PASSWORD FILE WITH THE PROGRAM : 'bpass'
 this is an example that use a password file called 'codes'.

 if you want to use this program instead of your login shell :
   
     YOU MUST EXECUTE go_shell TO COMPILE THIS PROGRAMME !!!!!!

 if you do not do that, you may not be able to log in your account 
 anymore ...

     This version show how to administrate several users when you 
     are just a simple user without root privilege:
     You have to compile this programm, and then you have to 
     make a passwd file with "bpass", after, you have to do 
                    chsh ~/bugs1_53/blogin username
     and then, when you enter your login and your passwd, a second 
     menu appear, the menu of blogin... 
     IMPORTANT: THe file codes MUST be in your root path (ex: ~/codes)
    
     Then, even if you give your first passwd to someone he won't be 
     able to come in your account.

     Caracteristics : 
	
             - FTP isn't available => more secure
             - Passwd file isn't readble by someone
             - You can allow only One or two commands to someone 
               (mail, news, etc)
     There's only ONE problem, if you're provider use the Pop mail server    
     If someone have the first passwd, he could read your mail.
*/

/*
 * This program has been only tested on a LINUX and HPUX OS
 * And I will not be responsible for anything if you use this program
 * It works for me and I find it very usefull, but is dangerous to use ...
 */

/*
 * HISTORY
 *
 * --- Version in progress ---
 *
 * --- V 1.9 ---
 *
 * 26/07/1999 : - Replaced sizeof() by strlen() while calling malloc()
 * 
 * 09/07/1999 : - Changed pass_clear from char to unsigned char
 *
 * --- V 1.8 ---
 *
 * 16/02/1998 : - Corrected the input password bug
 *		- Changed bcrypt initialisation (binit)
 *
 * --- V 1.7 ---
 *
 * 07/02/1998 : - Added the libcrypt version number
 *
 * --- V 1.6 ---
 *
 * 27/01/1998 : - Cleaned the source code
 *
 * --- V 1.5 ---
 * 
 * 19/01/1998 : - I added USER_LENGTH to varinit
 *
 * 17/01/1998 : - Change some variable names
 *
 * 15/01/1998 : - Added a malloc for the *varinit variable
 *
 * 11/01/1998 : - Added global variable VERSION
 *              - Started to do an HISTORY
 */

/*
 * This header is important
 * There is some global variables that you will need, eg:
 * USER_LENGTH = size of the string that contain the user name
 * other reserved variable name : KEYLENGTH, NB_CHAR, varinit->NB_INDEX, etc
 * Read the documentation or have a look of this header for more information
 */       
#include "../include/libcrypt.h"
#include "../include/extra.h"

char *VERSION="v1.9, July 1999";

/*
 * Default : mode = 0 (non verbose)
 *           Key's length = 128 bits
 */  
int MODE = 0;
int PARAM_KEY = 128;
char *PARAM_USER="";
globalvar *varinit;

/*
 * Password file
 */
char *path="bpasswd"; 

/*
 * Functions
 */

void usage(void);
int init(void);
int argcheck(int, char **);
int login(char **);

int 
main (int argc, char **argv)
{

/*
 * Use the following function to protect this program
 * against signal : not possible to interupt it
 */    
   bcrypt_signal();
   
   if (argcheck(argc, argv) == 0) return 0;
   if (init() == 0) return 0;
   if (login(argv) == 0) return 0;

return 1;
}

/*
 * Login function
 */
int login(char **argv)
{
  int test, i, length, RETURN = 10;
  char carac;
  unsigned char *pass_clear;
  TYPE_INT *code_file;
  
pass_clear = (unsigned char *) malloc (varinit->NB_CHAR);
code_file = (TYPE_INT *) malloc (varinit->NB_CHAR);

if (strlen(PARAM_USER) > varinit->USER_LENGTH)
   {
    printf("\n User name length too big. Max = '%d'.\n ERROR. \n",varinit->USER_LENGTH);
    return 0;
   }

  printf ("\n Login for %s\n", PARAM_USER);

  test = 0;

  if (bcrypt_read_passwd (PARAM_USER, path, code_file, MODE, varinit) != 0)
    {
      do{
      if (0 == MODE) system("clear");
      printf("\n BLOGIN %s, (C) Martinez Sylvain",VERSION);
      printf("\n Login demonstration program.");
      printf("\n Libcrypt version '%s'",varinit->LIB_VERSION);
      if (0 == MODE) gotoxy(20,10);
      else printf("\n");
      printf(" Welcome in BUGSLAND \n\n");
      if (0 == MODE) gotoxy(10,14);
      printf(" 1) Mail \n");
      if (0 == MODE) gotoxy(10,16);
      printf(" 2) Exit \n");
      if (0 == MODE) gotoxy(10,18);
      printf(" RETURN) Shell \n");
      carac = bcrypt_vol(1);
     /*
      * If you want your family to access only to their mail
      * then define a pine config where they can only access to one
      * mail folder
      * I use that with my family ...
      * after, I send mails on my account with a keyword, and this these mails
      * are automaticly saved in my family folder.
      */
      if (carac == '1' ) system("pine -p .pinerc_family");
      if (carac == '2' ) exit(1); 
      }while (carac != RETURN);

      printf ("\nPassword -> ");
      i = 0;
      do
	{
	  carac = bcrypt_vol (1);
	  if (carac != RETURN) pass_clear[i] = carac;
	  i++;
	}
      while (i < varinit->NB_CHAR && (carac != RETURN));
      if (carac == RETURN)
        {
        pass_clear[i - 1] = '\0';
        length = i - 1;
        }
       else
         length = i;

      test = blogin (code_file, pass_clear, length, 0, MODE, varinit);

    }
  else
    printf ("\n USER %s NOT REGISTRED ", PARAM_USER);
  if (test == 0)
    {
      printf ("\n ACCESS DENIED \n");
      return 0;
    }
  else
    {
      printf ("\n ACCESS ALLOWED \n");
      system("sh");
      return 1;
    }
}


/*
 * Initialised the global variables
 */
int init()
{
varinit = (globalvar *) malloc(sizeof(globalvar));
/*
 * The log will be generated in the stderr output
 */
binit(PARAM_KEY, 0, varinit);
return 1;
}

/*
 * Check the parameter of the program
 */
int argcheck(int argc, char **argv)
{
  int i;

  for (i = 0; i < argc; i++)
      {
	if ((0 == strcmp(argv[i],"-u")) && (i+1 < argc))
	   {
		PARAM_USER= (char *) malloc(strlen(argv[i+1]));
		strcpy(PARAM_USER, argv[i+1]);
	   }

	if ((0 == strcmp(argv[i],"-k")) && (i+1 < argc))
	   {
		PARAM_KEY = atoi(argv[i+1]);
	   }

	if (0 == strcmp(argv[i],"-v")) MODE = 1;
      }

   if (0 == strcmp(PARAM_USER,""))
      {
	usage();
	return 0;
      }

   if (fopen(path,"r") == 0)
       {
        printf("\n ERROR.");
        printf("\n password file '%s' not found. \n\n",path);
        return 0;
        }
return 1;
}
   
void usage()
{
  printf("\n BLOGIN %s, (C) Martinez Sylvain",VERSION);
  printf("\n\n USAGE : blogin -u USER {OPTIONS}");
  printf("\n\n {OPTIONS} :");
  printf("\n  -k nb : KEYLENGTH which has to be a 2 multiple integer.");
  printf("\n          At least 32.");
  printf("\n          DEFAULT = 128");
  printf("\n\n  -v : Verbose mode.\n\n");
}


