/*
 *  extra.h
 *
 *   EXTRA BUGS HEADER 
 *
 *   EXTRA MISCALLENAOUS FUNCTIONS 
 *   Version 1.2
 *   12 May 1998
 *
 *  -> new getchar() function
 *  -> Locate text on the screen function
 *  -> Erase screen function  
 *  -> Signal interrupt function  
 *
 *   Realised by MARTINEZ Sylvain
 *
 *   Based on the BUGS crypt's algorithm of MARTINEZ Sylvain
 *   (Big and Usefull Great Security)
 *
 *   UNIX Administrator (Merrill Lynch, UK)
 *   Network Security Consultant (ASI, France)
 *   Passion: Cryptology and Network Security
 *   email: martinez@asi.fr
 *          sylvain.martinez@netcourrier.com
 *   URL: http://www.asi.fr/~martinez
 *                                       
 *  Copyright (C) 1996,1997,1998,1999 MARTINEZ Sylvain
 *  THIS IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY IT UNDER
 *  THE TERMS OF THE GNU GENERAL PUBLIC LICENSE, see the file COPYING.
 * 
 */

#ifndef _EXTRA_H
#define _extra_h

#include <stdio.h>

#if defined(__FreeBSD__)
#include <sys/termios.h>
#include <sys/ttycom.h>
#else 
#include <termio.h>
#endif

/*
 * Used for the bcrypt_vol() function
 * only tested on Linux and HPUX
 */
#include <sys/ioctl.h>

/*
 * I use this header to stop any signal that can be send to the program
 */
#include <signal.h>

char bcrypt_vol(int);
void bcrypt_signal();
void bcrypt_end(int);
void gotoxy(int,int);

#endif






